QGIS Application - Bug report #11231
Function rand() only gives values up to ~32000
2014-09-19 07:03 AM - Matthias Kuhn

Status: Closed

Priority: Normal

Assignee:

Category: Expressions

Affected QGIS version:master Regression?: No
Operating System: Windows 7, 64 bit Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 19539
Description

On a spatialite layer, creating a new field with the field calculator and the expression "rand( 100000, 5000000 )" gives values of 100000 -
140000.

This seems not to be a problem on linux.

"randf()" also works properly.

The data type of the field was Integer.

QGIS was installed as 32bit.

History

#1 - 2014-10-04 05:25 AM - Giovanni Manghi
- Affected QGIS version changed from 2.4.0 to master

confirmed on the latest master on Windows (qgis 32 and 64 bit). Ok on Linux.

#2 - 2014-10-07 07:46 AM - Matthias Kuhn

Investigating a bit:

Visual Studio (up to 2013) has RAND_MAX defined as 0x7fff: 32767. Author's note: which seems quite stupid on a 32bit/64bit system.

(http://msdn.microsoft.com/en-us/library/2dfe3bzd.aspx)

A possibility to overcome this is to call rand() twice and bitshift/combine the values:
http://stackoverflow.com/questions/4832975/win32-higher-random-max-value

Or to use the <random> header file which is part of C++ 2011 and boost
http://msdn.microsoft.com/en-us/library/bb982398.aspx

#3 - 2017-05-01 01:08 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#4 - 2019-03-09 04:09 PM - Giovanni Manghi
- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/
